{
    "$graph": [
        {
            "class": "CommandLineTool",
            "label": "awk",
            "doc": "AWK command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:18.04",
                    "id": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Awk separator",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-F"
                    },
                    "id": "#awk.cwl/F"
                },
                {
                    "type": "File",
                    "doc": "Input file",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#awk.cwl/file"
                },
                {
                    "type": "string",
                    "doc": "Out put file name",
                    "id": "#awk.cwl/outFileName"
                },
                {
                    "type": "string",
                    "doc": "Awk text",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#awk.cwl/text"
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "awk"
            ],
            "id": "#awk.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#awk.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "grep",
            "doc": "GREP command",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "$import": "#ubuntu-docker.yml"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#grep.cwl/file"
                },
                {
                    "type": "string",
                    "id": "#grep.cwl/outFileName"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#grep.cwl/pattern"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-v"
                    },
                    "id": "#grep.cwl/v"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#grep.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "grep"
            ],
            "id": "#grep.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "doc": "SORT command",
            "label": "sort",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubuntu:18.04"
                }
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#sort.cwl/file",
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    }
                },
                {
                    "id": "#sort.cwl/k",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-k"
                    }
                },
                {
                    "id": "#sort.cwl/outFileName",
                    "type": "string"
                },
                {
                    "id": "#sort.cwl/u",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-u"
                    }
                },
                {
                    "id": "#sort.cwl/n",
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 0,
                        "prefix": "-n"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#sort.cwl/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.outFileName)"
                    }
                }
            ],
            "stdout": "$(inputs.outFileName)",
            "baseCommand": [
                "sort"
            ],
            "id": "#sort.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "label": "Samtools-faidx",
            "doc": "Samtools is a suite of programs for interacting with high-throughput sequencing data",
            "requirements": [
                {
                    "listing": [
                        "$(inputs.input)"
                    ],
                    "class": "InitialWorkDirRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/biocontainers/samtools:1.10--h9402c20_2",
                    "id": "#samtools-docker.yml"
                },
                {
                    "class": "SoftwareRequirement",
                    "packages": [
                        {
                            "package": "samtools",
                            "version": [
                                "1.10"
                            ],
                            "specs": [
                                "https://anaconda.org/bioconda/samtools"
                            ]
                        }
                    ],
                    "id": "#samtools-bioconda.yml"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-c"
                    },
                    "doc": "Continue after trying to retrieve missing region.\n",
                    "id": "#samtools-faidx.cwl/c"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-f"
                    },
                    "doc": "File and index in FASTQ format.\n",
                    "id": "#samtools-faidx.cwl/f"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "doc": "Reverse complement sequences.\n",
                    "id": "#samtools-faidx.cwl/i"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#samtools-faidx.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--mark-strand"
                    },
                    "doc": "Add strand indicator to sequence name\n    TYPE = rc   for /rc on negative strand (default)\n           no   for no strand indicator\n           sign for (+) / (-)\n           custom,<pos>,<neg> for custom indicator\n",
                    "id": "#samtools-faidx.cwl/mark_strand"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-n"
                    },
                    "doc": "Length of FASTA sequence line. [60]\n",
                    "id": "#samtools-faidx.cwl/n"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-o"
                    },
                    "doc": "Write FASTA to file.\n",
                    "id": "#samtools-faidx.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-r"
                    },
                    "doc": "File of regions.  Format is chr:from-to. One per line.\n",
                    "id": "#samtools-faidx.cwl/r"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    },
                    "id": "#samtools-faidx.cwl/output"
                }
            ],
            "baseCommand": [
                "samtools",
                "faidx"
            ],
            "id": "#samtools-faidx.cwl",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "label": "Creates FASTA file from BED coordinates",
            "doc": "This workflow creates FASTA file from BED coordinates",
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/bed"
                },
                {
                    "type": "File",
                    "id": "#main/fasta"
                },
                {
                    "type": "string",
                    "id": "#main/fasta_out"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/samtools_faidx/output",
                    "type": "File",
                    "id": "#main/output"
                }
            ],
            "steps": [
                {
                    "run": "#awk.cwl",
                    "in": [
                        {
                            "source": "#main/remove_comments/output",
                            "id": "#main/bedtocoord/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".coord\";}",
                            "id": "#main/bedtocoord/outFileName"
                        },
                        {
                            "default": "{printf(\"%s:%d-%d\\n\",$1,$2,$3)}",
                            "id": "#main/bedtocoord/text"
                        }
                    ],
                    "out": [
                        "#main/bedtocoord/output"
                    ],
                    "id": "#main/bedtocoord"
                },
                {
                    "run": "#grep.cwl",
                    "in": [
                        {
                            "source": "#main/bed",
                            "id": "#main/remove_comments/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".grep\";}",
                            "id": "#main/remove_comments/outFileName"
                        },
                        {
                            "default": "^#",
                            "id": "#main/remove_comments/pattern"
                        },
                        {
                            "default": true,
                            "id": "#main/remove_comments/v"
                        }
                    ],
                    "out": [
                        "#main/remove_comments/output"
                    ],
                    "id": "#main/remove_comments"
                },
                {
                    "run": "#samtools-faidx.cwl",
                    "in": [
                        {
                            "source": "#main/fasta",
                            "id": "#main/samtools_faidx/input"
                        },
                        {
                            "source": "#main/fasta_out",
                            "id": "#main/samtools_faidx/o"
                        },
                        {
                            "source": "#main/sort/output",
                            "id": "#main/samtools_faidx/r"
                        }
                    ],
                    "out": [
                        "#main/samtools_faidx/output"
                    ],
                    "id": "#main/samtools_faidx"
                },
                {
                    "run": "#sort.cwl",
                    "in": [
                        {
                            "source": "#main/bedtocoord/output",
                            "id": "#main/sort/file"
                        },
                        {
                            "valueFrom": "${ return inputs.file.nameroot + \".sort\";}",
                            "id": "#main/sort/outFileName"
                        },
                        {
                            "default": true,
                            "id": "#main/sort/u"
                        }
                    ],
                    "out": [
                        "#main/sort/output"
                    ],
                    "id": "#main/sort"
                }
            ],
            "id": "#main",
            "http://schema.org/author": [
                {
                    "class": "http://schema.org/Person",
                    "http://schema.org/identifier": "https://orcid.org/0000-0002-4108-5982",
                    "http://schema.org/email": "mailto:r78v10a07@gmail.com",
                    "http://schema.org/name": "Roberto Vera Alvarez"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "https://schema.org/version/latest/schemaorg-current-http.rdf"
    ],
    "$namespaces": {
        "s": "http://schema.org/"
    }
}
